//+------------------------------------------------------------------+
//|                                                  Trinves_EMA.mq4 |
//|                                                             2008 |
//+------------------------------------------------------------------+

#property link      "http://www.trinves.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Yellow //  EMA_55_Hight         |55 
#property indicator_width1 1      //  EMA_55_Hight     |
#property indicator_color2 Red    //  EMA_55_Low           |
#property indicator_width2 1      //  EMA_55_Low       |

#property indicator_color3 Yellow //  EMA_55_Hight         |
#property indicator_width3 1      //  EMA_55_Hight     |55 
#property indicator_style3 2      //  EMA_55_Hight        |
#property indicator_color4 Red    //  EMA_55_Low           |
#property indicator_width4 1      //  EMA_55_Low       |
#property indicator_style4 2      //  EMA_55_Low          |

#property indicator_color5 Yellow //  EMA_144_Hight        |144 
#property indicator_width5 2      //  EMA_144_Hight    |
#property indicator_color6 Red    //  EMA_55_144_Low       |
#property indicator_width6 2      //  EMA_144_Low      |

#property indicator_color7 Yellow //  EMA_144_Hight        |
#property indicator_width7 1      //  EMA_144_Hight    |55 
#property indicator_style7 1      //  EMA_144_Hight       |
#property indicator_color8 Red    //  EMA_144_Low          |
#property indicator_width8 1      //  EMA_144_Low      |
#property indicator_style8 1      //  EMA_144_Low         |



 int TimeFrame;
extern int MAPeriod=55;
extern int MAPeriod_2=144;
extern int ma_shift=0;
extern int ma_method=MODE_EMA;
 int applied_price_hight=PRICE_HIGH;
 int applied_price_low=PRICE_LOW;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexStyle(7,DRAW_LINE);
    
  }
//----
   return(0);
 

int start()
  {
  if (Period()==10080) {TimeFrame=43200;}
  if (Period()==1440) {TimeFrame=10080;}
  if (Period()==240) {TimeFrame=1440;}
  if (Period()==60) {TimeFrame=240;}
  if (Period()==30) {TimeFrame=240;}
  if (Period()==15) {TimeFrame=60;}
  if (Period()==5) {TimeFrame=30;}
  if (Period()==1) {TimeFrame=5;}
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 
    
   ExtMapBuffer1[i]=iMA(NULL,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price_hight,y) ; 
   ExtMapBuffer2[i]=iMA(NULL,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price_low,y) ; 
   ExtMapBuffer3[i]=iMA(NULL,0,MAPeriod,ma_shift,ma_method,applied_price_hight,i) ;
   ExtMapBuffer4[i]=iMA(NULL,0,MAPeriod,ma_shift,ma_method,applied_price_low,i) ;
   ExtMapBuffer5[i]=iMA(NULL,TimeFrame,MAPeriod_2,ma_shift,ma_method,applied_price_hight,y) ; 
   ExtMapBuffer6[i]=iMA(NULL,TimeFrame,MAPeriod_2,ma_shift,ma_method,applied_price_low,y) ; 
   ExtMapBuffer7[i]=iMA(NULL,0,MAPeriod_2,ma_shift,ma_method,applied_price_hight,i) ;
   ExtMapBuffer8[i]=iMA(NULL,0,MAPeriod_2,ma_shift,ma_method,applied_price_low,i) ;
   }  
     
   return(0);
  }
//+------------------------------------------------------------------+